=== debian/changelog ===
digikam (4:5.3.0-1) unstable; urgency=medium

  * New upstream.  Closes: #844126.
  - fixes encoded collection paths after upgrade from digikam v4.x.
    Closes: #834655.
  * digikam: add Depends on kipi-plugins.  Closes: #842112.
  * showfoto: strengthen dep on kipi-plugins from Recommends to Depends.
  * Build with ENABLE_KFILEMETADATASUPPORT=ON.
  * Build-Conflicts with libboost1.62-dev (<< 1.62.0+dfsg-4) because we
    need the degree-for-reverse_graph bug fix that is present in rev -4.

 -- Steve M. Robbins <smr@debian.org>  Sun, 13 Nov 2016 03:39:25 -0600

digikam (4:5.2.0-3) unstable; urgency=medium

  * Add build-dep on gphoto2.  Closes: #842094.
  * Build with -DENABLE_MEDIAPLAYER=ON.  Closes: #834131.
  * Build with -DENABLE_APPSTYLES=ON.  Closes: #842567.

 -- Steve M. Robbins <smr@debian.org>  Tue, 01 Nov 2016 01:06:53 -0500

digikam (4:5.2.0-2) unstable; urgency=medium

  * Add missing dependency for libqt5sql5-mysql.  Closes: #834365.
  * Rebuild will update libmarblewidget-qt5 dependency.  Closes: #840841,
    #841751.

 -- Steve M. Robbins <smr@debian.org>  Sun, 23 Oct 2016 11:39:28 -0500

digikam (4:5.2.0-1) unstable; urgency=medium

  [ Pino Toscano ]
  * Remove the alternative mplayerthumbs recommend, since it is dead and
    scheduled for removal from Debian.

  [ Steve Robbins ]
  * New upstream release (Closes: #838886).  Thanks to Norbert Preining
    for the patch.
  * patches/cmake-fix-doc-translated.patch: Remove; doc-translated no
    longer contains content.
  * patches/upstream-gcc6-fix.patch: Remove; applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Mon, 26 Sep 2016 00:08:15 -0500

digikam (4:5.1.0-2) unstable; urgency=medium

  * Team upload.
  * Replace the libgusb-dev build dependency with libusb-1.0-0-dev (but only
    for Linux).
  * Remove myself from Uploaders.
  * Switch from the specific libboost-graph1.60-dev to the default
    libboost-graph-dev. (Closes: #834175)
  * Enable again support for address book, adding the libkf5akonadicontact-dev
    build dependency.
  * Update watch file, letting it follow only stable versions.
  * Fix typo in copyright.

 -- Pino Toscano <pino@debian.org>  Sat, 13 Aug 2016 22:56:45 +0200

digikam (4:5.1.0-1) unstable; urgency=medium

  * New release.  Closes: #803456.
    - Add NEWS.Debian to describe configuration migration.
  * Update patches.
    - cmake-disable-doc-translated-showfoto.patch: Remove.
    - upstream-gcc6-fix.patch: New.  GCC 6.1/32bit fix from upstream git.
    - cmake-fix-doc-translated.patch: New.  Fix generation of translated docs.

 -- Steve M. Robbins <smr@debian.org>  Thu, 11 Aug 2016 00:42:31 -0500

digikam (4:5.0.0-1) experimental; urgency=medium

  * Staging the 5.0.0 release.
    - Updated all build-depends.
    - Remove obsolete cmake flags DIGIKAMSC_COMPILE_LIBKFACE, ENABLE_LCMS2,
      KDE4_BUILD_TESTS.

  * Update patches.
    - doc-linkage.patch: 
    - sendimages-icedove.diff: Remove.  Patched file no longer
      in sources.
    - mysql-global-conf.patch:
    - upstream_fix-compilation-with-Lensfun-0.3.2.patch: Remove.
      Applied upstream.
    - cmake-disable-jasper.patch: New.  Disable build-time probe
      for Jasper libraries.

 -- Steve M. Robbins <smr@debian.org>  Sun, 10 Jul 2016 11:04:43 -0500
